require("distance calc")
require("removekey")

function love.load()
	print("Loading...")
	width, height, flags = love.window.getMode()
	love.graphics.setBackgroundColor(0,0,130)
	p = {x = width/2, y = height/2, speed = 4, img = love.graphics.newImage('assets/player.png'),collects=0}
	pWidth = p.img:getWidth()
	pHeight = p.img:getHeight()
	base = {x = 100,y = 100, collects = 0,img = love.graphics.newImage('assets/base.png')}
	base_pave1 = love.graphics.newImage("assets/base_pave1.png")
	baseWidth = base.img:getWidth()
	baseHeight = base.img:getHeight()
	mapLimit = 800

	shootSound = love.audio.newSource("assets/Sounds/shoot.wav",'static')

	guiFont = love.graphics.newFont("assets/font2.TTF",35)
	textShadow = love.graphics.newImage("assets/text_shadow.png")


	collects = {}
	collectImage = love.graphics.newImage("assets/collect.png")
	numCollects = 10 -- Number of collectables
	collectIncr = 1
	--Generate Collects
	for i=1, numCollects,1 do
		collects[collectIncr] = {x=love.math.random(-mapLimit,mapLimit-30),y=love.math.random(-mapLimit,mapLimit-30)}
		collectIncr = collectIncr + 1
	end

	--Enemies
	enemies = {}
	enemyImage = love.graphics.newImage("assets/enemy.png")
	eWidth = enemyImage:getWidth()
	eHeight = enemyImage:getHeight()
	numEnemies = 10
	eSpeed = 2
	for i=1,numEnemies,1 do
		enemies[i] = {x=love.math.random(-mapLimit,mapLimit-30),y=love.math.random(-mapLimit,mapLimit-30)}
	end

	--Bullets
	bulletImage = love.graphics.newImage("assets/bullet.png")
	bWidth = bulletImage:getWidth()
	bHeight = bulletImage:getHeight()
	bullets = {}
	bnum = 0--increments with each bullet fired in a game
			--So that each bullet key is unique.
	bSpeed = 12
	
	--Trees and Map objects
	oakImg = love.graphics.newImage("assets/oak.png")
	oakWidth = oakImg:getWidth()
	oakHeight = oakImg:getHeight()
	pineImg = love.graphics.newImage("assets/pine.png")
	pineWidth = pineImg:getWidth()
	pineHeight = pineImg:getHeight()
	numTrees = 80
	trees = {}
	for i=1,numTrees,1 do
		trees[i] = {tree = love.math.random(0,1),x=love.math.random(-mapLimit,mapLimit-oakWidth),y=love.math.random(-mapLimit,mapLimit-oakHeight)}
	end


	MAPGREEN = {21,135,17}


	camerax = p.x
	cameray = p.y

	up = false
	down = false
	right = false
	left = false

	gamestate = 'game'

end

function love.update(dt)

	if gamestate == 'game' then
		--Move Player
		if up then
			p.y = p.y - p.speed
		end

		if down then
			p.y = p.y + p.speed
		end
		if left
		 then
			p.x = p.x - p.speed
		end
		if right then
			p.x = p.x + p.speed
		end

		--Move Camera
		if p.x < 130 then
			p.x = 130
			camerax = camerax + p.speed
		end

		if p.x+pWidth > width- 130 then
			p.x = (width-130) - pWidth
			camerax = camerax - p.speed
		end

		if p.y < 130 then
			p.y = 130
			cameray = cameray + p.speed
		end

		if p.y+pHeight > height-130 then
			p.y = (height-130)-pHeight
			cameray = cameray - p.speed
		end

		--Keep Player inside map
		if p.x < -mapLimit+camerax then
			p.x = -mapLimit+camerax
		end
		if p.x+pWidth > mapLimit+camerax then
			p.x = (mapLimit+camerax)-pWidth
		end
		if p.y < -mapLimit+cameray then
			p.y = -mapLimit+cameray
		end
		if p.y + pHeight > mapLimit+cameray then
			p.y = (mapLimit+cameray)-pHeight
		end
		--Move bullets and remove excess
		count = 0
		for k,v in pairs(bullets) do
			v.bx = v.bx + v.xD * bSpeed
			v.by = v.by + v.yD * bSpeed

			--check for bullet hitting enemy
			for k,e in pairs(enemies) do
				if v.bx + 30 > e.x +camerax and v.bx < e.x + eWidth+camerax and v.by +30 > e.y +cameray and v.by< e.y+eHeight + cameray then
					table.remove(enemies,k)
					hitSound = love.audio.newSource("assets/Sounds/hit.wav")
					love.audio.play(hitSound)
				end
			end

			count = count + 1
		end
		if count >= 15 then
			for i= 1,count-15,1 do
				table.remove(bullets,i)
			end
		end
		--Check for player-enemy collision
		for k,v in pairs(enemies) do
			if distance_calc(p.x,p.y,v.x+camerax,v.y+cameray) < 300 then --Enemy Detects player
				run = p.x - (v.x+camerax)
				rise = p.y - (v.y+cameray)
				length = math.sqrt((rise*rise) + (run*run))
				v.x = v.x + (run/length) * eSpeed
				v.y = v.y + (rise/length) * eSpeed
			end


			if p.x < v.x+eWidth+camerax and p.x+pWidth > v.x+camerax and p.y < v.y+eHeight+cameray and p.y+pHeight > v.y+cameray then
				if p.collects >= 1 then
					for i=1, p.collects,1 do
						collects[collectIncr] = {x=p.x-camerax+math.random(-8,8),y=p.y-cameray+math.random(-8,8)}
						collectIncr = collectIncr + 1
						p.collects = p.collects -1
					end
				end	
				p.x = width/2
				p.y = height/2
				camerax = p.x
				cameray = p.y
			end
		end

		--Check for collectable collisions and add to player
		for k,v in pairs(collects) do
			if p.x < v.x+30+camerax and p.x+pWidth > v.x+camerax and p.y < v.y+30+cameray and p.y+pHeight > v.y+cameray then
				table.removekey(collects,k)
				p.collects = p.collects+1
			end
		end
		--Check for player at base and drop collectables
		if p.x < base.x+baseWidth+camerax and p.x+pWidth > base.x+camerax and p.y < base.y+baseWidth+cameray and p.y + pHeight > base.y+cameray then
			base.collects = base.collects + p.collects
			p.collects = 0
		end
		--Check for Game complete(all collects in base)
		if base.collects == numCollects then
			gamestate = 'finish'
		end
	end
end
---------------------------------------------------------------
--#############################################################
--                          DRAWING
--#############################################################
---------------------------------------------------------------
function love.draw()
	--Active game Screen
	if gamestate == 'game' then
		love.graphics.setColor(MAPGREEN)
		love.graphics.rectangle("fill",-mapLimit+camerax,-mapLimit+cameray,mapLimit*2,mapLimit*2)
		love.graphics.setColor(255,255,255)--Reset Color to default

		love.graphics.draw(base.img,base.x+camerax,base.y+cameray)--Draw Base
		love.graphics.draw(base_pave1,base.x+camerax-50,base.y+cameray-46)
		--Draw Trees and map objects
		for k,v in pairs(trees) do
			if v.tree == 0 then
				love.graphics.draw(oakImg,v.x+camerax,v.y+cameray)
			elseif v.tree == 1 then
				love.graphics.draw(pineImg,v.x+camerax,v.y+cameray)
			end
		end
		love.graphics.draw(p.img, p.x, p.y)--Draw Player
		--Draw Bullets
		for k,v in pairs(bullets) do
			love.graphics.draw(bulletImage,v.bx,v.by)
		end
		--Draw the collectables
		for k,v in pairs(collects) do
			love.graphics.draw(collectImage,v.x+camerax,v.y+cameray)
		end

		--Draw Enemies
		for k,v in pairs(enemies) do
			love.graphics.draw(enemyImage,v.x+camerax,v.y+cameray)
		end

		love.graphics.setFont(guiFont)
		love.graphics.draw(textShadow,0,-8)
		love.graphics.setColor(210,210,210)
		love.graphics.print("Player Coins:"..p.collects,10,0)
		love.graphics.print("Base Coins:"..base.collects,10,30)
		love.graphics.setColor(255,255,255)--Reset Color to default

	--Draw Game Complete Screen
	elseif gamestate == 'finish' then
		love.graphics.setBackgroundColor(0,0,0)
		love.graphics.print("Congratulations! You Won!. Press 'r' to restart.",20,love.graphics.getHeight()/2)--Temp
	end

	

end

function love.mousepressed(x,y,button)
	shootSound = love.audio.newSource("assets/Sounds/shoot.wav",'static')
	love.audio.play(shootSound)
	run = x - p.x-20--Not sure why the 20 works...it just does
	rise = y - p.y-20
	length = math.sqrt((rise*rise) + (run*run))

	bullets[bnum] = {bx=p.x+(pWidth/2)-(bWidth/2),by=p.y+(pHeight/2)-(bHeight/2),xD = run/length,yD=rise/length}
	bnum = bnum + 1
end

function love.mousereleased(x,y,button)

end

function love.keypressed(key)
	if key == 'w' then
		up = true

	elseif key == 's' then
		down = true

	elseif key == 'd' then
		right = true

	elseif key == 'a' then
		left = true

	elseif key == 'r' and gamestate == 'finish' then--Temp
		love.load()
	end

end

function love.keyreleased(key)
	if key == 'w' then
		up = false

	elseif key == 's' then
		down = false

	elseif key == 'd' then
		right = false

	elseif key == 'a' then
		left = false
	end
end
function love.quit()
	love.event.quit()
end
